

-- JaggedArrays（ジャグ配列）tblの各値をKeyにして、
-- table化した多次元のindexを値として収納するlocationsを作る。
-- 手袋を裏返すイメージ。
-- recはindexの履歴を収めるtable。枝分かれの都度Copyし、
-- 以前の履歴と連動しないようにする。
function _indexer (tbl,rec,locations)
  local copy 
  local tp 
  for i,val in pairs(tbl) do
    copy = table.copy(rec) -- Renoise API
    tp = type(val) 
    copy[((table.maxn(copy) +1))] = i 
    if
      (tp ~= 'table'
      and (tp == 'string' or tp == 'number'))
    then
     locations[val] = copy
      copy = {}
    elseif
      tp == 'table'
    then
      _indexer(val,copy,locations)
    else return nil
    end
  end
end


function indexer4jagged (table)
  local locations ={}
  local rec ={}
  _indexer (table,rec,locations)
  return locations
end
 


-- {2,3,4} のようなindex_tblから、
-- tbl[2][3][4]を返す。無ければ、nil。
function return_val (tbl,index_tbl)
  local v =tbl 
  if ((index_tbl==nil)or(type(index_tbl)~='table'))
  then v=nil
  else
    local max =#index_tbl
    for i,idx in pairs(index_tbl) do
      v = v[idx]
      if (v==nil) and (i<max) then
        return nil
      end
    end
  end
  return v
end

